<?php
/*  
* Reads snmp statistics fron mikrotik routers and passes them to cacti script
* To be used for signal level collection. 
* NOTES : It is not tested with client aps
* NOTES : When many clients are associated the script (hopefully) returns stats for the last client listed
 * Creds . SNMP tutorial by gandalf 
*version 0.9
*by basOS Nov 2007 - Jan 2008
*/
# deactivate http headers
$no_http_headers = true;
/* display No errors */
error_reporting(E_ERROR);
# include some cacti files for ease of use
include_once(dirname(__FILE__) . "/../include/config.php");
include_once(dirname(__FILE__) . "/../lib/snmp.php");

if (!isset($called_by_script_server)) {
        array_shift($_SERVER["argv"]);
        print call_user_func_array("ss_mkt_wstat", $_SERVER["argv"]);
}

function ss_mkt_wstat ($hostname , $snmp_community, $snmp_version ,
							$snmp_port = 161, $snmp_timeout = 500,
							$cmd, $query_field = "", $query_index = "" ) 
{
#Snmp v3 with username/password not yet supported
$snmp_user = "" ;
$snmp_pw = "" ;
# define all OIDs we need (and not only) for further processing
$oids = array(
		# Standart oids
        "index"         => ".1.3.6.1.2.1.2.2.1.1",
        "iftype"        => ".1.3.6.1.2.1.2.2.1.3",
        "ifHWaddress"   => ".1.3.6.1.2.1.2.2.1.6",
        
        ##### ONLY IN CLIENT MODE ####
        #get hwaddress of a connection (mac address of the access point for a client)
        "iwbssid"	=> ".1.3.6.1.4.1.14988.1.1.1.1.1.6",
        #get ssid of a connection
        "iwssid"	=> ".1.3.6.1.4.1.14988.1.1.1.1.1.5",
        "iwtxrate"	=> ".1.3.6.1.4.1.14988.1.1.1.1.1.2",
        "iwrxrate"	=> ".1.3.6.1.4.1.14988.1.1.1.1.1.3",
        
        ##### REG TABLE STUFF #####
        #get signal from reg table/ Apend hw address in decimal . index
        "iwrtsignal"	=> ".1.3.6.1.4.1.14988.1.1.1.2.1.3",
        "iwrttxrate"	=> ".1.3.6.1.4.1.14988.1.1.1.2.1.8",
        "iwrtrxrate"	=> ".1.3.6.1.4.1.14988.1.1.1.2.1.9",
        "iwrtcmac" 		=> ".placeholder",
		
		# Clasic Oids (for all ifs)
        "ifstatus"      => ".1.3.6.1.2.1.2.2.1.8",
        "ifdescription" => ".1.3.6.1.2.1.2.2.1.2",
        "ifname"        => ".1.3.6.1.2.1.31.1.1.1.1",
        "ifalias"       => ".1.3.6.1.2.1.31.1.1.1.18",
        "ifspeed"       => ".1.3.6.1.2.1.2.2.1.5",
        "ifInOctets"    => ".1.3.6.1.2.1.2.2.1.10",
        "ifOutOctets"   => ".1.3.6.1.2.1.2.2.1.16",
        );
$xml_delimiter          =  "!";

# all required input parms
/*$hostname       = $_SERVER["argv"][1];
$snmp_community = $_SERVER["argv"][2];
$snmp_version   = $_SERVER["argv"][3];
$snmp_port      = $_SERVER["argv"][4];
$snmp_timeout   = $_SERVER["argv"][5];
$snmp_user      = $_SERVER["argv"][6];
$snmp_pw        = $_SERVER["argv"][7];
$cmd            = $_SERVER["argv"][8];
if (isset($_SERVER["argv"][9]))  { $query_field = $_SERVER["argv"][9]; };
if (isset($_SERVER["argv"][10])) { $query_index = $_SERVER["argv"][10]; };*/

# get number of snmp retries from global settings
$snmp_retries   = read_config_option("snmp_retries");

# -------------------------------------------------------------------------
# script MUST respond to index queries
#       the command for this is defined within the XML file as
#       <arg_index>index</arg_index>
#       you may replace the string "index" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> index
# will all indices of the target values
# e.g. in case of interfaces
#      it has to respond with the list of interface indices
# -------------------------------------------------------------------------
    

if ($cmd == "index" || $cmd == "query") {
        # retrieve all indices from target
		$type_arrl = ss_mkt_wstat_reindexv(cacti_snmp_walk($hostname, $snmp_community, $oids["iftype"],
                                              $snmp_version, $snmp_user, $snmp_pw, $snmp_port,
                                              $snmp_timeout, $snmp_retries)); 
		if (!$type_arrl) {
			print "Error parsing indexes\n" ;
			exit(-200) ;
		}
		 $type_arr = array();
		 while (list($iidx, $value) = each($type_arrl)) {
	     	#Only return indexes of wlan cards 
	       	# tip : iftype =  ieee80211(71)
	       	if ($value == "ieee80211(71)" )
				$type_arr[$iidx] = 1;
	      }
}



if ($cmd == "index" || ($cmd == "query" && $query_field == "index")) {
		$retv = "";
        while (list($iidx) = each($type_arr)) {
             	$retv .= $iidx.($query_field == "index"? ($xml_delimiter.$iidx) : "") . "\n" ;
        }
		return $retv;
		//print "DBG end index \n";
#
# -------------------------------------------------------------------------
# script MUST respond to query requests
#       the command for this is defined within the XML file as
#       <arg_query>query</arg_query>
#       you may replace the string "query" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> query <function>
# where <function> is a parameter that tells this script,
# which target value should be retrieved
# e.g. in case of interfaces, <function> = ifdescription
#      it has to respond with the list of
#      interface indices along with the description of the interface
# -------------------------------------------------------------------------
}elseif ($cmd == "query") {
        #$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"],
        #                                     $snmp_version, $snmp_user, $snmp_pw, $snmp_port,
        #                                     $snmp_timeout, $snmp_retries));
		
		if (empty($query_field)) {
			print "query need a query field\n" ;
			return -300;
		}
		if (empty($oids[$query_field])) {
			print "invalid query item \n";
			return -310;
		}
		
		$qf=($query_field=="iwrtcmac" ? "iwrtsignal" : $query_field);
        $arr = cacti_snmp_walk($hostname, $snmp_community, 
								$oids[$qf],
                                $snmp_version, $snmp_user, $snmp_pw, $snmp_port,
                                $snmp_timeout, $snmp_retries, SNMP_POLLER);
		if ($query_field == "iwrtcmac") {
			$arr_res = ss_mkt_wstat_reindexm($arr);
			$retv = "" ;
	        while (list($iidx) = each ($type_arr)) {
	                $retv .= $iidx . $xml_delimiter . $arr_res[$iidx] . "\n" ;		
			}
			return $retv;
		}
		else  { //($query_field == "iwrtsignal" || $query_field == "iwrtrxrate" || $query_field == "iwrttxrate") 
			$arr_res = ss_mkt_wstat_reindexv($arr);
			$retv = "";
	        while (list($iidx) = each ($type_arr)) {
	                $retv .= $iidx . $xml_delimiter . $arr_res[$iidx] . "\n" ;		
			}
			return $retv;
		}
      
# 
# -------------------------------------------------------------------------
# script MUST respond to get requests
#       the command for this is defined within the XML file as
#       <arg_get>get</arg_get>
#       you may replace the string "get" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> get <function> <index>
# where <function> is a parameter that tells this script,
# which target value should be retrieved
# and   <index>    is the index that should be queried
# e.g. in case of interfaces, <function> = ifdescription
#                             <index>    = 1
#      it has to respond with
#      the description of the interface for interface #1
# -------------------------------------------------------------------------
}elseif ($cmd == "get") {
		if (empty($query_field)) {
			print "get needs a query field\n" ;
			return -300;
		}
		if (empty($query_index)) {
			print "get needs a query index\n" ;
			return -300;
		}
		if (empty($oids[$query_field])) {
			print "invalid get item \n";
			return -310;
		}
        $arr = cacti_snmp_walk($hostname, $snmp_community, 
								$oids[$query_field=="iwrtcmac" ? "iwrtsignal" : $query_field],
                                $snmp_version, $snmp_user, $snmp_pw, $snmp_port,
                                $snmp_timeout, $snmp_retries);

		if ($query_field == "iwrtcmac") {
			$arr_res = ss_mkt_wstat_reindexm($arr);
	        return $arr_res[$query_index] ;	
		}
		else { //($query_field == "iwrtsignal" || $query_field == "iwrtrxrate" || $query_field == "iwrttxrate") 
			$arr_res = ss_mkt_wstat_reindexv($arr);
	        return $arr_res[$query_index] ;		
		}
                              
# -------------------------------------------------------------------------
# -------------------------------------------------------------------------
} else {
        print "Invalid use of script query, required parameters:\n\n";
        print "    <hostname> <community> <version> <snmp_port> <timeout> <user> <pw> <cmd>\n";
		return -100;
}
}
/*function reindex($arr) {
        $return_arr = array();

        for ($i=0;($i<sizeof($arr));$i++) {
                $return_arr[$i] = $arr[$i]["value"];
        }
        return $return_arr;
}*/

function ss_mkt_wstat_getmac($oid_s) {
		if (!ereg("([0-9]*)\.([0-9]*)\.([0-9]*)\.([0-9]*)\.([0-9]*)\.([0-9]*)\.([0-9]*)$",$oid_s,$regs)) 
		//if (!ereg("([0-9]*\.){6}([0-9]*)$",$oid_s,$regs)) 
					return FALSE;
		$mac = sprintf('%02X:%02X:%02X:%02X:%02X:%02X',$regs[1],$regs[2],$regs[3],$regs[4],$regs[5],$regs[6]);
		return $mac;
}

function ss_mkt_wstat_getidx($oid_s) {
		if (!ereg("[0-9]*$",$oid_s,$regs)) 
					return FALSE;
		$idx = $regs[0];
		return $idx;
}

#reindex values according to the last part of oid
function ss_mkt_wstat_reindexv ($arr) {
		$return_arr = array();
        for ($i=0;($i<sizeof($arr));$i++) {
			$idx = ss_mkt_wstat_getidx($arr[$i]["oid"]);
			if (!$idx)
				return FALSE;					
            $return_arr[$idx] = $arr[$i]["value"];
	    }
		return $return_arr;
}

#reindex macs according to the last part of oid
function ss_mkt_wstat_reindexm($arr) {
	$return_arr = array();
	
	for ($i=0;($i<sizeof($arr));$i++) {
		$idx = ss_mkt_wstat_getidx($arr[$i]["oid"]);
		if (!$idx)
			return FALSE;	
		$cmac = ss_mkt_wstat_getmac($arr[$i]["oid"]);
		if (!$cmac) 
			return FALSE;
		$return_arr[$idx] = $cmac;
	} 
	return $return_arr;
}

#snmp_walk return format
#Array 
#(
#    [0] => Array
#        (
#            [oid] => 1.3.6.1.2.1.2.2.1.1.1
#            [value] => 1
#        )
#
#    [1] => Array
#        (
#            [oid] => 1.3.6.1.2.1.2.2.1.1.2
#            [value] => 2
#        )
#)
?>                            
